<?php

function custom_theme_setup() {
  add_theme_support( 'post-thumbnails' ); /* アイキャッチ */
  add_theme_support( 'automatic-feed-links' ); /* RSSフィード */
  add_theme_support( 'title-tag' ); /* タイトルタグ自動生成 */
  add_theme_support( 'html5', array( /* HTML5のタグで出力 */
    'search-form',
    'comment-form',
    'comment-list',
    'gallery',
    'caption',
  ) );
}
add_action( 'after_setup_theme', 'custom_theme_setup' );

//css読み込み
function alice_styles() {
  wp_enqueue_style( 'stylealice', get_template_directory_uri() . '/style.css', array(), '1.0.3' );
}
add_action( 'wp_enqueue_scripts', 'alice_styles' );

//メニューの登録
function register_my_menus() {
  register_nav_menus( array(
    'top-menu' => 'Top Menu',
    'footer-menu' => 'Footer Menu',
  ) );
}
add_action( 'after_setup_theme', 'register_my_menus' );

//ウィジェットの登録
function my_widget_init() {
  register_sidebar( array(
    'id' => 'sidebar',
    'before_widget' => '<div class="widget">',
    'after_widget' => '</div>',
    'before_title' => '<h4 class="widget_title">',
    'after_title' => '</h4>',
  ) );

  register_sidebar( array(
    'name' => 'Footer',
    'id' => 'footer',
    'before_widget' => '<div class="footer-widget">',
    'after_widget' => '</div>',
    'before_title' => '<h4 class="widget_title">',
    'after_title' => '</h4>'
  ) );
}
add_action( 'widgets_init', 'my_widget_init' );


//画像の一枚目をサムネイルに
function catch_that_image() {
  global $post, $posts;
  $first_img = '';
  ob_start();
  ob_end_clean();
  $output = preg_match_all( '/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches );
  $first_img = $matches[ 1 ][ 0 ];

  if ( empty( $first_img ) ) {
    $first_img = "https://a-littledream.com/wp-content/themes/alice/images/noimage.jpg";
  }
  return $first_img;
}

function catch_that_imager() {
  global $post, $posts;
  $first_img = '';
  ob_start();
  ob_end_clean();
  $output = preg_match_all( '/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches );
  $first_img = $matches[ 1 ][ 0 ];

  if ( empty( $first_img ) ) {
    $first_img = "https://a-littledream.com/wp-content/themes/alice/images/noimage-related.jpg";
  }
  return $first_img;
}

function catch_that_images() {
  global $nextpost;
  $first_img = '';
  ob_start();
  ob_end_clean();
  $output = preg_match_all( '/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $nextpost->post_content, $matches );
  $first_img = $matches[ 1 ][ 0 ];

  if ( empty( $first_img ) ) {
    $first_img = "https://a-littledream.com/wp-content/themes/alice/images/noimage.jpg";
  }
  return $first_img;
}

function catch_that_imagess() {
  global $prevpost;
  $first_img = '';
  ob_start();
  ob_end_clean();
  $output = preg_match_all( '/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $prevpost->post_content, $matches );
  $first_img = $matches[ 1 ][ 0 ];

  if ( empty( $first_img ) ) {
    $first_img = "https://a-littledream.com/wp-content/themes/alice/images/noimage.jpg";
  }
  return $first_img;
}

//SVGファイルをアップロードできるようにする
function my_upload_mimes( $mimes = array() ) {
  $mimes[ 'svg' ] = 'image/svg+xml';
  return $mimes;
}
add_filter( 'upload_mimes', 'my_upload_mimes' );

//youtube動画のレスポンシブ化
function iframe_in_div( $the_content ) {
  if ( is_singular() ) {
    $the_content = preg_replace( '/<iframe/i', '<div class="youtube"><iframe', $the_content );
    $the_content = preg_replace( '/<\/iframe>/i', '</iframe></div>', $the_content );
  }
  return $the_content;
}

add_filter( 'the_content', 'iframe_in_div' );

//検索結果に投稿記事のみを表示する
function custom_search_result( $query ) {
  if ( !$query->is_admin && $query->is_main_query() && $query->is_search ) {
    $query->set( 'post_type', 'post' );
  }
  return $query;
}
add_filter( 'pre_get_posts', 'custom_search_result' );

//セルフピンバックを無効にする
function no_self_ping( & $links ) {
  $home = get_option( 'home' );
  foreach ( $links as $l => $link )
    if ( 0 === strpos( $link, $home ) )
      unset( $links[ $l ] );
}
add_action( 'pre_ping', 'no_self_ping' );